// Read the config file

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "defines.h"

extern char *sensorname[];

extern fan_t fan[];

extern int interval;

int readconfig(char *name)
{
	int i,cursensor=0;

	char row[100],*retval,
		 p1[100],p2[100],p3[100];
	float p4,p5,p6,p7;

	FILE *f;

	// Reset all global values
	interval=10;

	for(i=0;i<MAXSENSORS;i++)
		sensorname[i]=NULL;

	for(i=0;i<MAXFANS;i++)
	{
		fan[i].type=UNUSED;
		fan[i].oldduty=0;
	}

	f=fopen(name,"r");
	if(f==NULL)
		return -1;

	// Start reading the lines
	while(!feof(f))
	{
		retval=fgets(row,sizeof(row),f);

		if(row[0]!='\n' && retval)
		{
			// Start extracting the info
			sscanf(row,"%s%s%s%f%f%f%f",p1,p2,p3,&p4,&p5,&p6,&p7);

			// Sensor found
			if(!strcmp(p1,"sensor:"))
			{
				sensorname[cursensor]=strdup(p2);
				cursensor++;
			}

			// Interval found
			if(!strcmp(p1,"interval:"))
				interval=atoi(p2);

			// And a fan
			if(!strcmp(p1,"fan:"))
			{
				i=atoi(p2);
				if(!strcmp(p3,"dynamic"))
				{
					fan[i].type=DYNAMIC;

					fan[i].mintemp=p4;
					fan[i].maxtemp=p5;
					fan[i].minduty=fan[i].duty=p6;
					fan[i].maxduty=p7;
				}
				else
				{
					fan[i].type=CONSTANT;
					fan[i].duty=p4;
				}
			}
		}
	}

	return 0;
}
