// Find the relevant devices and display info on them

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "QstCfg.h"

char *readfile(char *name)
{
	FILE *f;
	static char biggie[100]; // Oh well

	f=fopen(name,"r");
	if(f==NULL)
		return NULL;

	fscanf(f,"%s",biggie);
	fclose(f);

	return biggie;
}

void detect(void)
{
	char *FanMonStr[] =
	{
	    "Other/Unknown Fan",
	    "Processor Fan",
	    "Processor Thermal Module Fan",
	    "Memory Controller Hub Fan",
	    "Voltage Regulator Fan",
	    "Chassis Fan",
	    "Chassis Inlet Fan",
	    "Chassis Outlet Fan",
	    "Power Supply Fan",
	    "Power Supply Inlet Fan",
	    "Power Supply Outlet Fan",
	    "Hard Drive Fan",
	    "Graphics Processor fan",
	    "Auxiliary Fan",
	    "I/O Hub Fan",
	    "Peripheral Controller Hub (PCH) Fan",
	 	"Memory Fan"
	};

	int i,j;
	char fnam[100],*ret;

	// Find coretemp(s?)
	puts("\nDetected coretemp devices:");

	for(i=0;i<10;i++)
	{
		// Check each
		sprintf(fnam,"%s%d%s","/sys/class/hwmon/hwmon",i,"/name");
		ret=readfile(fnam);
		if(ret && !strcmp(ret,"coretemp"))
		{
			printf("  /sys/class/hwmon/hwmon%d\n",i);
			puts("  with temperature sensors:");

			// Find temp sensors
			for(j=0;j<10;j++)
			{
				sprintf(fnam,"%s%d%s%d%s","/sys/class/hwmon/hwmon",i,
						              "/temp",j,"_input");
				ret=readfile(fnam);
				if(ret)
				{
					printf("    %s: %.2f\n",fnam,atof(ret)/1000.0);
				}
			}
			puts("");
		}
	}

	// Moving on to MEI stuff
	if(!InitializeQst())
	{
		UINT32 dwError=(UINT32)errno;
		puts("Cannot initialize QST.");
		exit((int)dwError);
	}

	// Print each MEI controlled fan number and usage
	printf("Detected %d fans:\n",GetDutyCountQst());
	for(i=0;i<GetDutyCountQst();i++)
	{
		printf("  %d is a %s\n",i,FanMonStr[GetDutyUsageQst(i)]);
	}

	puts("");

	CleanupQst();
}
